; 
    include \masm32\include\masm32rt.inc
    include winio.inc
    includelib winio.lib
    include smbios.inc
; 

    .data
      hPhysMem              dd 0
      structureTableLength  dd 0
      structureTableAddress dd 0
      numberOfStructures    dd 0
    .code

; 

FindStructure proc startAddress:DWORD,structureType:DWORD,nStructures:DWORD

    push ebx
    mov ebx, startAddress
    mov ecx, nStructures
    mov eax, structureType
  @@:  
    cmp [ebx].SMB_STRUCTURE_HEADER.structureType, al
    je  @F
    movzx edx, [ebx].SMB_STRUCTURE_HEADER.formattedLength
    add ebx, edx
    .while word ptr[ebx]
      inc ebx
    .endw
    add ebx, 2
    dec ecx
    jnz @B
  @@:
    mov eax, ebx
    pop ebx
    ret

FindStructure endp

; 

FindString proc structureAddress:DWORD,stringIndex:DWORD

    mov eax, structureAddress
    movzx edx, [eax].SMB_STRUCTURE_HEADER.formattedLength
    add eax, edx
    mov ecx, stringIndex
    .while ecx > 1
      .while byte ptr[eax] != 0
        inc eax
      .endw
      inc eax
      dec ecx
    .endw
  @@:
    ret

FindString endp

; 
start:
; 
    invoke InitializeWinIo

    invoke MapPhysToLin, 0F0000h, 10000h, ADDR hPhysMem
    mov   ebx, eax

    xor esi, esi
    .while esi < 10000h

      .if dword ptr[ebx+esi] == "_MS_"

        print "SMBIOS version "
        xor eax, eax
        mov al,[ebx+esi].SMB_ENTRY_POINT_STRUCTURE.smbMajorVersion
        print ustr$(eax),"."
        mov al,[ebx+esi].SMB_ENTRY_POINT_STRUCTURE.smbMinorVersion
        print ustr$(eax),13,10

        movzx eax,[ebx+esi].SMB_ENTRY_POINT_STRUCTURE.structureTableLength
        mov structureTableLength, eax
        mov eax,[ebx+esi].SMB_ENTRY_POINT_STRUCTURE.structureTableAddress
        mov structureTableAddress, eax
        movzx eax,[ebx+esi].SMB_ENTRY_POINT_STRUCTURE.numberOfStructures
        mov numberOfStructures, eax

        print "Structure Table Length "
        print ustr$(structureTableLength),13,10
        print "Structure Table Address "
        print uhex$(structureTableAddress),13,10
        print "Structure Table number of structures "
        print ustr$(numberOfStructures),13,10,13,10

        .break

      .endif

      add esi, 16

    .endw

    .if esi == 10000h

      print "SMBIOS Structure Table Entry Point not found",13,10
      inkey "Press any key to exit..."
      exit      

    .endif

    ; --------------------------------------------------
    ; The structure table can be at any 32-bit address.
    ; --------------------------------------------------

    invoke UnmapPhysicalMemory, hPhysMem, ebx

    invoke MapPhysToLin, structureTableAddress,
                         structureTableLength,
                         ADDR hPhysMem
    mov ebx, eax

    invoke FindStructure, ebx, SMB_TYPE_BIOS_INFO, numberOfStructures
    mov esi, eax
    invoke FindString, esi, 1       ; vendor$
    print eax,13,10
    invoke FindString, esi, 2       ; version$
    print eax,13,10
    invoke FindString, esi, 3       ; releaseDate$
    print eax,13,10,13,10

    movzx eax, [esi].SMB_BIOS_INFO.startSeg
    print uhex$(eax),13,10,13,10

    invoke FindStructure, ebx, SMB_TYPE_SYSTEM_INFO, numberOfStructures
    mov esi, eax
    invoke FindString, esi, 4       ; serialNumber$
    print eax,13,10,13,10

    invoke UnmapPhysicalMemory, hPhysMem, ebx
    
    invoke ShutdownWinIo

    inkey "Press any key to exit..."
    exit
; 
end start